using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
using System.IO;
using UnityEngine.SceneManagement;
using System.Reflection;
using System.Collections;
using System.Threading.Tasks;
using System.Linq;

namespace Mod
{
    public class Mod
    {
        public static float Damage;
        public static Texture2D trail = ModAPI.LoadTexture("trail.png");
        public static Texture2D ltrail = ModAPI.LoadTexture("ltrail.png");

        public static void Main()
        {
            ModAPI.OnItemSpawned += (sender, obj) =>
            {
                GameObject gameObject = obj.Instance;
                if (gameObject.transform.root.gameObject.GetComponent<FirearmBehaviour>() && !gameObject.GetComponent<PhysBullets>())
                {
                    gameObject.AddComponent<PhysBullets>();
                }
            };
             ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "PhysBullet",
        DescriptionOverride = "", 
        AfterSpawn = (Instance) => 
        {
           Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("bullet.png");
           Instance.AddComponent<DebrisComponent>();
           Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass *= Settings.BulletWeightMultiplier;
            Instance.GetComponent<PhysicalBehaviour>().InitialMass *= Settings.BulletWeightMultiplier;
            Instance.transform.localScale *= Settings.BulletSizeMultiplier;
            foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
        {
            GameObject.Destroy(ColliderBoxDeleteVar);
        }
        Instance.FixColliders();
            var phys = Instance.GetComponent<PhysicalBehaviour>();
            var prop = ModAPI.FindPhysicalProperties("Weapon");
            prop.Sharp = true;
            prop.SharpAxes = new[]
            {
                            new SharpAxis(Vector2.right, 0f, 0.1f, true, false),
                                                        new SharpAxis(Vector2.left, 0f, 0.1f, true, false),
                                                                                    new SharpAxis(Vector2.down, 0f, 0.1f, true, false),
                                                                                                                new SharpAxis(Vector2.up, 0f, 0.1f, true, false),
                };
        phys.Properties = prop;
            //Instance.GetComponent<SpriteRenderer>().color = Color.clear;
            var trailrenderer = Instance.AddComponent<TrailRenderer>();
        trailrenderer.startWidth = 0.08f * Settings.BulletSizeMultiplier;
        trailrenderer.endWidth = 0.08f * Settings.BulletSizeMultiplier;
        trailrenderer.time = Settings.BulletTrailLifetime;
        trailrenderer.startColor = new Color32(255, 255, 255, 10);
        trailrenderer.endColor = new Color32(255, 255, 255, 5);
        Material mat = new Material(ModAPI.FindMaterial("VeryBright"));
        mat.SetTexture("_MainTex", Mod.trail);
        trailrenderer.material = mat;
        trailrenderer.sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder = 1;
        Instance.AddComponent<DeleteOverTime>();
                           }
                        }
                      );
                      ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "BuckPhysBullet",
        DescriptionOverride = "", 
        AfterSpawn = (Instance) => 
        {
           Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("pelt.png");
           Instance.AddComponent<DebrisComponent>();
           Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass *= Settings.BulletWeightMultiplier / 1.5f;
            Instance.GetComponent<PhysicalBehaviour>().InitialMass *= Settings.BulletWeightMultiplier / 1.5f;
            Instance.transform.localScale *= Settings.BulletSizeMultiplier;
            foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
        {
            GameObject.Destroy(ColliderBoxDeleteVar);
        }
        Instance.FixColliders();
            var phys = Instance.GetComponent<PhysicalBehaviour>();
            var prop = ModAPI.FindPhysicalProperties("Weapon");
            prop.Sharp = true;
            prop.SharpAxes = new[]
            {
                            new SharpAxis(Vector2.right, 0f, 0.1f, true, false),
                                                        new SharpAxis(Vector2.left, 0f, 0.1f, true, false),
                                                                                    new SharpAxis(Vector2.down, 0f, 0.1f, true, false),
                                                                                                                new SharpAxis(Vector2.up, 0f, 0.1f, true, false),
                };
        phys.Properties = prop;
            //Instance.GetComponent<SpriteRenderer>().color = Color.clear;
            var trailrenderer = Instance.AddComponent<TrailRenderer>();
        trailrenderer.startWidth = 0.06f * Settings.BulletSizeMultiplier;
        trailrenderer.endWidth = 0.06f * Settings.BulletSizeMultiplier;
        trailrenderer.time = Settings.BulletTrailLifetime;
        trailrenderer.startColor = new Color32(255, 255, 255, 10);
        trailrenderer.endColor = new Color32(255, 255, 255, 5);
        Material mat = new Material(ModAPI.FindMaterial("VeryBright"));
        mat.SetTexture("_MainTex", Mod.trail);
        trailrenderer.material = mat;
        trailrenderer.sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder = 1;
        Instance.AddComponent<DeleteOverTime>();
                           }
                        }
                      );
                      ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "SlugPhysBullet",
        DescriptionOverride = "", 
        AfterSpawn = (Instance) => 
        {
           Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slug.png");
           Instance.AddComponent<DebrisComponent>();
           Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass *= Settings.BulletWeightMultiplier * 2f;
            Instance.GetComponent<PhysicalBehaviour>().InitialMass *= Settings.BulletWeightMultiplier * 2f;
            Instance.transform.localScale *= Settings.BulletSizeMultiplier;
            foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
        {
            GameObject.Destroy(ColliderBoxDeleteVar);
        }
        Instance.FixColliders();
            var phys = Instance.GetComponent<PhysicalBehaviour>();
            var prop = ModAPI.FindPhysicalProperties("Weapon");
            prop.Sharp = true;
            prop.SharpAxes = new[]
            {
                            new SharpAxis(Vector2.right, 0f, 0.1f, true, false),
                                                        new SharpAxis(Vector2.left, 0f, 0.1f, true, false),
                                                                                    new SharpAxis(Vector2.down, 0f, 0.1f, true, false),
                                                                                                                new SharpAxis(Vector2.up, 0f, 0.1f, true, false),
                };
        phys.Properties = prop;
            //Instance.GetComponent<SpriteRenderer>().color = Color.clear;
            var trailrenderer = Instance.AddComponent<TrailRenderer>();
        trailrenderer.startWidth = 0.1f * Settings.BulletSizeMultiplier;
        trailrenderer.endWidth = 0.1f * Settings.BulletSizeMultiplier;
        trailrenderer.time = Settings.BulletTrailLifetime;
        trailrenderer.startColor = new Color32(255, 255, 255, 10);
        trailrenderer.endColor = new Color32(255, 255, 255, 5);
        Material mat = new Material(ModAPI.FindMaterial("VeryBright"));
        mat.SetTexture("_MainTex", Mod.trail);
        trailrenderer.material = mat;
        trailrenderer.sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder = 1;
        Instance.AddComponent<DeleteOverTime>();
                           }
                        }
                      );
                      ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "LaserPhysBullet",
        DescriptionOverride = "", 
        AfterSpawn = (Instance) => 
        {
           Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("laser.png");
           Instance.AddComponent<DebrisComponent>();
           Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass *= Settings.BulletWeightMultiplier;
            Instance.GetComponent<PhysicalBehaviour>().InitialMass *= Settings.BulletWeightMultiplier;
            Instance.transform.localScale *= Settings.BulletSizeMultiplier;
            foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
        {
            GameObject.Destroy(ColliderBoxDeleteVar);
        }
        Instance.FixColliders();
            var phys = Instance.GetComponent<PhysicalBehaviour>();
            var prop = ModAPI.FindPhysicalProperties("Weapon");
            prop.Sharp = true;
            prop.SharpAxes = new[]
            {
                            new SharpAxis(Vector2.right, 0f, 0.1f, true, false),
                                                        new SharpAxis(Vector2.left, 0f, 0.1f, true, false),
                                                                                    new SharpAxis(Vector2.down, 0f, 0.1f, true, false),
                                                                                                                new SharpAxis(Vector2.up, 0f, 0.1f, true, false),
                };
        phys.Properties = prop;
            //Instance.GetComponent<SpriteRenderer>().color = Color.clear;
            var trailrenderer = Instance.AddComponent<TrailRenderer>();
        trailrenderer.startWidth = 0.1f * Settings.BulletSizeMultiplier;
        trailrenderer.endWidth = 0.1f * Settings.BulletSizeMultiplier;
        trailrenderer.time = Settings.BulletTrailLifetime;
        trailrenderer.startColor = new Color32(255, 255, 255, 10);
        trailrenderer.endColor = new Color32(255, 255, 255, 5);
        Material mat = new Material(ModAPI.FindMaterial("VeryBright"));
        mat.SetTexture("_MainTex", Mod.ltrail);
        trailrenderer.material = mat;
        trailrenderer.sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder = 1;
        Instance.AddComponent<slice>();
        Instance.AddComponent<DeleteOverTime>();
                           }
                        }
                      );
                       ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "CannonPhysBullet",
        DescriptionOverride = "", 
        AfterSpawn = (Instance) => 
        {
           Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("cannon.png");
           Instance.AddComponent<DebrisComponent>();
           Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass *= Settings.BulletWeightMultiplier * 30f;
            Instance.GetComponent<PhysicalBehaviour>().InitialMass *= Settings.BulletWeightMultiplier * 30f;
            Instance.transform.localScale *= Settings.BulletSizeMultiplier;
            foreach (var ColliderBoxDeleteVar in Instance.GetComponents<Collider2D>())
        {
            GameObject.Destroy(ColliderBoxDeleteVar);
        }
        Instance.FixColliders();
            //Instance.GetComponent<SpriteRenderer>().color = Color.clear;
            var trailrenderer = Instance.AddComponent<TrailRenderer>();
        trailrenderer.startWidth = 0.15f * Settings.BulletSizeMultiplier;
        trailrenderer.endWidth = 0.15f * Settings.BulletSizeMultiplier;
        trailrenderer.time = Settings.BulletTrailLifetime;
        trailrenderer.startColor = new Color32(255, 255, 255, 10);
        trailrenderer.endColor = new Color32(255, 255, 255, 5);
        Material mat = new Material(ModAPI.FindMaterial("VeryBright"));
        mat.SetTexture("_MainTex", Mod.trail);
        trailrenderer.material = mat;
        trailrenderer.sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder = 1;
        Instance.AddComponent<DeleteOverTime>();
                           }
                        }
                      );
        }
    }
    public class slice : MonoBehaviour
  {
    public void OnCollisionEnter2D(Collision2D other)
        {
          if (other.gameObject.layer == 9)
          {
            if (other.gameObject.GetComponent<LimbBehaviour>())
            {
           other.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.Cut((Vector2) other.transform.position, UnityEngine.Random.insideUnitCircle);
            }
           other.gameObject.transform.SendMessage("Slice", SendMessageOptions.DontRequireReceiver);
            Destroy(gameObject);
          }
    }
  }
    public class DeleteOverTime : MonoBehaviour
    {
        public bool hit = false;
        public float anim = 115f;
        private Vector2 GetHitPoint(Collider2D coll) => gameObject.GetComponent<Collider2D>().ClosestPoint(coll.ClosestPoint((Vector2) this.transform.position));

        public void OnCollisionEnter2D(Collision2D other)
        {
            if (!other.gameObject.GetComponent<DeleteOverTime>() && !gameObject.GetComponent<FreezeBehaviour>())
            {
                if (!hit)
                {
            Vector3 hitPoint = (Vector3) this.GetHitPoint(other.gameObject.GetComponent<Collider2D>());
            Vector3 normalized = (this.transform.position - hitPoint).normalized;
            float damage = Mod.Damage;
            other.gameObject.GetComponent<PhysicalBehaviour>().BroadcastMessage("Shot", (object) new Shot((Vector2) normalized, (Vector2) hitPoint, damage, false), SendMessageOptions.DontRequireReceiver);
            if (other.gameObject.GetComponent<DestroyableBehaviour>())
            {
                System.Random rand = new System.Random();
                            var number = rand.Next(3);
                            if (number == 1)
                            {
                                other.gameObject.GetComponent<DestroyableBehaviour>().Break();
                            }
            }
            if (Settings.ExplosiveBullets)
            {
                gameObject.AddComponent<ExplosiveBehaviour>();
         gameObject.GetComponent<ExplosiveBehaviour>().ArmOnAwake = true;
         gameObject.GetComponent<ExplosiveBehaviour>().Delay = 0f;
         System.Random rand = new System.Random();
                            var number = rand.Next(3);
                            if (number == 1)
                            {
                                gameObject.GetComponent<ExplosiveBehaviour>().ParticleEffectAndSound = false;
                            }
                            else
                            {
                                gameObject.GetComponent<ExplosiveBehaviour>().ParticleEffectAndSound = true;
                            }
         gameObject.GetComponent<ExplosiveBehaviour>().FragmentationRayCount = 128;
         gameObject.GetComponent<ExplosiveBehaviour>().FragmentForce = 1;
         gameObject.GetComponent<ExplosiveBehaviour>().Range = 3;
         gameObject.GetComponent<ExplosiveBehaviour>().ShockwaveLiftForce = 0.2f;
         gameObject.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 0.8f;
            }
            if (other.gameObject.GetComponent<LimbBehaviour>())
            {
                if (!Settings.GetStuckInLimbs && !Settings.ExplosiveBullets)
                {
                    hit = true;
                gameObject.GetComponent<Rigidbody2D>().velocity *= 0f;
                Destroy(gameObject);
                }
                else
                {
                    hit = true;
                Destroy(gameObject.GetComponent<DeleteOverTime>());
                }
            }
            StartCoroutine(Delete());
            }
            }
        }
        private IEnumerator Delete()
{
    yield return new WaitForSeconds(Settings.BulletLifetime);
    for (float i = 0f; i < anim; i++)
        {
          transform.localScale *= 0.99f;
          yield return new WaitForSeconds(0.005f);
        }
    Destroy(gameObject);
}
    }
    public class PhysBullets : MonoBehaviour
    {
        //recoilMultiplier = 1f;
        //muzzleFlashPrefab;
        //ScreenShake;
        bool Multi = false;
        int BulletsPerShot;
        int butPos;
        public string Bullet = "Default";
        int OgBullets;
        bool IsBuck = false;

        void CheckDialogArea(DialogBox dialogBox)
        {
            DialogBox dialog = null;
            switch (butPos)
            {
                case 0:
                    dialog = DialogBoxManager.TextEntry("Change bullet type", "",
                    new DialogButton("<-", true, new UnityAction[1]
                    {
                        (() =>
                        {
                            if (butPos == 0)
                            {
                                dialog.Close();
                                return;
                            }
                            butPos--;
                            CheckDialogArea(dialog);
                        })
                    }),
                    new DialogButton("Default", true, new UnityAction[1]
                    {
                        () =>
                        {
                            Bullet = "Default";
                            if (IsBuck)
                            {
                                BulletsPerShot = OgBullets;
                                IsBuck = false;
                                Multi = false;
                            }
                        }
                    }),
                    new DialogButton("Slugshot", true, new UnityAction[1]
                    {
                        () =>
                        {
                            Bullet = "Slug";
                            if (IsBuck)
                            {
                                BulletsPerShot = OgBullets;
                                IsBuck = false;
                                Multi = false;
                            }
                        }
                    }),
                    new DialogButton("->", true, new UnityAction[1]
                    {
                        (() =>
                        {
                            if (butPos == 2)
                                return;
                            butPos++;
                            CheckDialogArea(dialog);
                        })
                    }));
                    dialog.ShowTextBox = false;
                    dialogBox = dialog;
                    break;
                case 1:
                    dialog = DialogBoxManager.TextEntry("Change bullet type", "",
                    new DialogButton("<-", true, new UnityAction[1]
                    {
                        (() =>
                        {
                            if (butPos == 0)
                                return;
                            butPos--;
                            CheckDialogArea(dialog);
                        })
                    }),
                    new DialogButton("Buckshot", true, new UnityAction[1]
                    {
                        () =>
                        {
                            Bullet = "Buck";
                            if (!Multi)
                            {
                                Multi = true;
                                BulletsPerShot += 4;
                                IsBuck = true;
                            }
                        }
                    }),
                    new DialogButton("Laser Bullet", true, new UnityAction[1]
                    {
                        () =>
                        {
                            Bullet = "Laser";
                            if (IsBuck)
                            {
                                BulletsPerShot = OgBullets;
                                IsBuck = false;
                                Multi = false;
                            }
                        }
                    }),
                    new DialogButton("->", true, new UnityAction[1]
                    {
                        () =>
                        {
                            if (butPos == 2)
                                return;
                            butPos++;
                            CheckDialogArea(dialog);
                        }
                    }));
                    dialog.ShowTextBox = false;
                    dialogBox = dialog;
                    break;
                case 2:
                    dialog = DialogBoxManager.TextEntry("Change bullet type", "",
                    new DialogButton("<-", true, new UnityAction[1]
                    {
                        () =>
                        {
                            if (butPos == 0)
                                return;
                            butPos--;
                            CheckDialogArea(dialog);
                        }
                    }),
                    new DialogButton("Cannonball", true, new UnityAction[1]
                    {
                        () =>
                        {
                            Bullet = "Cannon";
                            if (IsBuck)
                            {
                                BulletsPerShot = OgBullets;
                                IsBuck = false;
                                Multi = false;
                            }
                        }
                    }),
                    new DialogButton("->", true, new UnityAction[1]
                    {
                        () =>
                        {
                            if (butPos == 2)
                            {
                                dialog.Close();
                                return;
                            }
                            butPos++;
                            CheckDialogArea(dialog);
                        }
                    }));
                    dialog.ShowTextBox = false;
                    dialogBox = dialog;
                    break;
            }
        }

        public void Update()
        {
            if (Settings.ShareProperties && Bullet == "Default")
            {
                if (gameObject.GetComponent<FreezeBehaviour>())
                {
                    ModAPI.FindSpawnable("PhysBullet").Prefab.GetOrAddComponent<FreezeBehaviour>();
                }
                else
                {
                    if (ModAPI.FindSpawnable("PhysBullet").Prefab.GetComponent<FreezeBehaviour>())
                    {
                        Destroy(ModAPI.FindSpawnable("PhysBullet").Prefab.GetComponent<FreezeBehaviour>());
                    }
                }
                ModAPI.FindSpawnable("PhysBullet").Prefab.GetComponent<PhysicalBehaviour>().Charge = gameObject.GetComponent<PhysicalBehaviour>().Charge;
                ModAPI.FindSpawnable("PhysBullet").Prefab.GetComponent<PhysicalBehaviour>().Temperature = gameObject.GetComponent<PhysicalBehaviour>().Temperature;
            }

            if (Bullet == "Default")
            {
                gameObject.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("PhysBullet");
            }

            if (Bullet == "Buck")
            {
                gameObject.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("BuckPhysBullet");
            }

            if (Bullet == "Slug")
            {
                gameObject.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("SlugPhysBullet");
            }

            if (Bullet == "Laser")
            {
                gameObject.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("LaserPhysBullet");
            }

            if (Bullet == "Cannon")
            {
                gameObject.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("CannonPhysBullet");
            }

        }

       void Start()
       {
           var c = gameObject.GetComponent<FirearmBehaviour>().Cartridge;
           var g = gameObject.GetComponent<FirearmBehaviour>();
           var p = gameObject.AddComponent<ProjectileLauncherBehaviour>();
           p.barrelPosition = g.barrelPosition;
           p.barrelDirection = g.barrelDirection;
           p.IsAutomatic = g.Automatic;
           p.AutomaticInterval = g.AutomaticFireInterval;
           p.projectileAsset = ModAPI.FindSpawnable("PhysBullet");
           Mod.Damage = c.Damage * Settings.DamageMultiplier;
           p.projectileLaunchStrength = c.StartSpeed * Settings.SpeedMultiplier;
           p.recoilMultiplier = c.Recoil * 0.1f;
           OgBullets = g.BulletsPerShot;
           if (g.BulletsPerShot > 1)
           {
               BulletsPerShot = g.BulletsPerShot - 1;
               Multi = true;
           }
           g.BulletsPerShot = 0;

           gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("gasbut", "Change bullet type", "Change bullet type", new UnityAction[1]
            {
                () =>
                {
                    butPos = 0;
                    CheckDialogArea(null);
                }
            }));

       }

       void Use()
       {
           if (Multi)
           {
               for (int i = 0; i < BulletsPerShot; i++)
        {
               gameObject.GetComponent<ProjectileLauncherBehaviour>().Launch();
           }
           }
       }
    }   
}