using System;
using UnityEngine;

namespace Mod
{
    public class Settings
    {
        //Modify values here to your liking

        public static float BulletLifetime = 2f; //How long should a bullet exist after hitting an object? Default is 2f (Keep low to avoid lag)

        public static bool GetStuckInLimbs = false; //Controls if a bullet should stay inside of a limb after making contact. Default is false

        public static float DamageMultiplier = 1f; //Multiplies the damage output of bullets. Default is 1f

        public static float SpeedMultiplier = 0.6f; //Modifys the speed of bullets, recommended to keep below values of 1. Default is 0.6f

        public static float BulletWeightMultiplier = 1f; //Modifys how much a bullet weighs, accounts for bullet drop and velocity. Default is 1f

        public static float BulletTrailLifetime = 0.06f; //How long the trail should exist behind the bullet, completely visual and has no effect. Default is 0.06f

        public static float BulletSizeMultiplier = 1f; //Multiplies the size of the bullets. Default is 1f

        public static bool ExplosiveBullets = false; //Makes bullets create a small explosion on impact. Default is false

        public static bool ShareProperties = true; //Shares physical properties between the gun and the bullet (the charge of the gun will equal the charge of the bullet, the temperature of the gun will equal the temperature of the bullet, etc) Default is true

    }
}